summaryrefslogtreecommitdiffstats
path: root/init.d
diff options
context:
space:
mode:
authorNatanael Copa <ncopa@alpinelinux.org>2009-06-10 17:36:46 +0000
committerNatanael Copa <ncopa@alpinelinux.org>2009-06-10 17:36:46 +0000
commit5b098951181f360627ff58b680da3d3987a7865f (patch)
tree7a3cec1ee21cc8d354627ad28c2b55d43cc7928d /init.d
parent9542c009af40331e8770256148aa13075f4d8294 (diff)
downloadalpine-baselayout-5b098951181f360627ff58b680da3d3987a7865f.tar.bz2
alpine-baselayout-5b098951181f360627ff58b680da3d3987a7865f.tar.xz
init.d/mdev: split mdev into mdev and mdev-mount
This is how udev does it
Diffstat (limited to 'init.d')
-rwxr-xr-xinit.d/mdev23
-rwxr-xr-xinit.d/mdev-mount56
2 files changed, 62 insertions, 17 deletions
diff --git a/init.d/mdev b/init.d/mdev
index fb9e8d5..90cb378 100755
--- a/init.d/mdev
+++ b/init.d/mdev
@@ -9,36 +9,25 @@ depend() {
start() {
# check if udev is specified on cmd line
- for i in `cat /proc/cmdline 2>/dev/null`; do
- [ "$i" = "udev" ] && return 0
- done
+ if get_bootparam "udev"; then
+ ewarn "Skipping mdev as udev requested in kernel cmdline"
+ return 0
+ fi
ebegin "Starting mdev"
mkdir -p /dev
- # start mdev
- mount -t tmpfs -o exec,nosuid,mode=0755 mdev /dev
- mknod -m 666 /dev/null c 1 3
-
# use mdev for hotplug
echo "/sbin/mdev" > /proc/sys/kernel/hotplug
# create devices
mdev -s
- RC=$?
-
- # create pts file system
- [ -d /dev/pts ] || mkdir -m 755 /dev/pts
- [ -c /dev/ptmx ] || mknod -m 666 /dev/ptmx c 5 2
- mount -t devpts -o gid=5,mode=0620,noexec,nosuid devpts /dev/pts
- [ -d /dev/shm ] || mkdir /dev/shm
- mount -t tmpfs -o nodev,nosuid,noexec shm /dev/shm
- eend $RC
+ eend $?
}
stop() {
ebegin "Stopping mdev"
echo "" > /proc/sys/kernel/hotplug
- umount /dev/pts && umount /dev/shm && umount /dev
eend
}
+
diff --git a/init.d/mdev-mount b/init.d/mdev-mount
new file mode 100755
index 0000000..4896445
--- /dev/null
+++ b/init.d/mdev-mount
@@ -0,0 +1,56 @@
+#!/sbin/runscript
+# Largely based on Gentoo's udev-mount
+#
+# Copyright 1999-2008 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+#
+
+description="Mount tmpfs on /dev"
+
+mount_dev_directory()
+{
+ # No options are processed here as they should all be in /etc/fstab
+ ebegin "Mounting /dev"
+ mkdir -p /dev
+ if fstabinfo --quiet /dev; then
+ mount -n /dev
+ else
+ # Some devices require exec, Bug #92921
+ mount -n -t tmpfs -o "exec,nosuid,mode=0755,size=10M" mdev /dev
+ fi
+ eend $?
+}
+
+seed_dev()
+{
+ # Seed /dev with some things that we know we need
+
+ # creating /dev/console, /dev/tty and /dev/tty1 to be able to write
+ # to $CONSOLE with/without bootsplash before udevd creates it
+ [ -c /dev/console ] || mknod -m 600 /dev/console c 5 1
+ [ -c /dev/tty1 ] || mknod -m 620 /dev/tty1 c 4 1
+ [ -c /dev/tty ] || mknod -m 666 /dev/tty c 5 0
+
+ # udevd will dup its stdin/stdout/stderr to /dev/null
+ # and we do not want a file which gets buffered in ram
+ [ -c /dev/null ] || mknod -m 666 /dev/null c 1 3
+
+ # so udev can add its start-message to dmesg
+ [ -c /dev/kmsg ] || mknod -m 660 /dev/kmsg c 1 11
+
+ # Not provided by sysfs but needed
+ ln -snf /proc/self/fd /dev/fd
+ ln -snf fd/0 /dev/stdin
+ ln -snf fd/1 /dev/stdout
+ ln -snf fd/2 /dev/stderr
+ [ -e /proc/kcore ] && ln -snf /proc/kcore /dev/core
+
+ # Create problematic directories
+ mkdir -p /dev/pts /dev/shm
+ return 0
+}
+
+start() {
+ mount_dev_directory || return 1
+ seed_dev
+}